Index: admin/_charte.php
===================================================================
--- admin/_charte.php	(revision 2760)
+++ admin/_charte.php	(revision 3355)
@@ -79,6 +79,6 @@
 	<div id="wrapper" class="clearfix">
 		<div class="hidden-if-no-js collapser-box"><a href="#" id="collapser">
-		<img class="collapse-mm" src="images/collapser-hide.png" alt="Cacher le menu" />
-		<img class="expand-mm" src="images/collapser-show.png" alt="Montrer le menu" />
+		<img class="collapse-mm visually-hidden" src="images/collapser-hide.png" alt="Cacher le menu" />
+		<img class="expand-mm visually-hidden" src="images/collapser-show.png" alt="Montrer le menu" />
 		</a></div>
 		<div id="main">
Index: admin/auth.php
===================================================================
--- admin/auth.php	(revision 3358)
+++ admin/auth.php	(revision 3352)
@@ -88,5 +88,5 @@
 		$recover_key = $core->auth->setRecoverKey($user_id,$user_email);
 
-		$subject = mail::B64Header('Dotclear '.__('Password reset'));
+		$subject = mail::B64Header('DotClear '.__('Password reset'));
 		$message =
 		__('Someone has requested to reset the password for the following site and username.')."\n\n".
@@ -113,5 +113,5 @@
 		$recover_res = $core->auth->recoverUserPassword($akey);
 
-		$subject = mb_encode_mimeheader('Dotclear '.__('Your new password'),'UTF-8','B');
+		$subject = mb_encode_mimeheader('DotClear '.__('Your new password'),'UTF-8','B');
 		$message =
 		__('Username:').' '.$recover_res['user_id']."\n".
@@ -119,5 +119,5 @@
 		preg_replace('/\?(.*)$/','',$page_url);
 
-		$headers[] = 'From: '.(defined('DC_ADMIN_MAILFROM') && DC_ADMIN_MAILFROM ? DC_ADMIN_MAILFROM : 'dotclear@local');
+		$headers[] = 'From: dotclear@'.$_SERVER['HTTP_HOST'];
 		$headers[] = 'Content-Type: text/plain; charset=UTF-8;';
 
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 3270)
+++ admin/blog_pref.php	(revision 3330)
@@ -313,4 +313,9 @@
 
 $desc_editor = $core->auth->getOption('editor');
+$rte_flag = true;
+$rte_flags  = @$core->auth->user_prefs->interface->rte_flags;
+if (is_array($rte_flags) && in_array('blog_descr',$rte_flags)) {
+	$rte_flag = $rte_flags['blog_descr'];
+}
 
 dcPage::open(__('Blog settings'),
@@ -324,7 +329,6 @@
 	"</script>".
 	dcPage::jsConfirmClose('blog-form').
-	$core->callBehavior('adminPostEditor',$desc_editor['xhtml'],'blog_desc',array('#blog_desc'),'xhtml').
+	($rte_flag ? $core->callBehavior('adminPostEditor',$desc_editor['xhtml'],'blog_desc',array('#blog_desc'),'xhtml') : '').
 	dcPage::jsLoad('js/_blog_pref.js').
-
 
 	# --BEHAVIOR-- adminBlogPreferencesHeaders
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 3210)
+++ admin/categories.php	(revision 3340)
@@ -47,5 +47,5 @@
 		$mov_cat = (int) $_POST['mov_cat'][$cat_id];
 
-		$mov_cat = $mov_cat ? $mov_cat : null;
+		$mov_cat = $mov_cat ?: null;
 		if ($mov_cat !== null) {
 			$c = $core->blog->getCategory($mov_cat);
Index: admin/category.php
===================================================================
--- admin/category.php	(revision 3209)
+++ admin/category.php	(revision 3330)
@@ -175,9 +175,14 @@
 
 $category_editor = $core->auth->getOption('editor');
+$rte_flag = true;
+$rte_flags  = @$core->auth->user_prefs->interface->rte_flags;
+if (is_array($rte_flags) && in_array('cat_descr',$rte_flags)) {
+	$rte_flag = $rte_flags['cat_descr'];
+}
 
 dcPage::open($title,
 	dcPage::jsConfirmClose('category-form').
 	dcPage::jsLoad('js/_category.js').
-	$core->callBehavior('adminPostEditor',$category_editor['xhtml'],'category',array('#cat_desc'),'xhtml'),
+	($rte_flag ? $core->callBehavior('adminPostEditor',$category_editor['xhtml'],'category',array('#cat_desc'),'xhtml') : ''),
 	dcPage::breadcrumb($elements)
 );
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 3263)
+++ admin/comments.php	(revision 3360)
@@ -43,7 +43,14 @@
 __('Date') => 'comment_dt',
 __('Entry title') => 'post_title',
+__('Entry date') => 'post_dt',
 __('Author') => 'comment_author',
 __('Status') => 'comment_status'
 );
+
+$sortby_lex = array(
+	// key in sorty_combo (see above) => field in SQL request
+	'post_title' => 'post_title',
+	'comment_author' => 'comment_author',
+	'comment_spam_filter' => 'comment_spam_filter');
 
 $order_combo = array(
@@ -133,6 +140,11 @@
 # Sortby and order filter
 if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if (array_key_exists($sortby,$sortby_lex)) {
+		$params['order'] = $core->con->lexFields($sortby_lex[$sortby]);
+	} else {
+		$params['order'] = $sortby;
+	}
 	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
+		$params['order'] .= ' '.$order;
 	} else {
 		$order = 'desc';
Index: admin/csp_report.php
===================================================================
--- admin/csp_report.php	(revision 3293)
+++ admin/csp_report.php	(revision 3324)
@@ -8,6 +8,8 @@
 header('X-Content-Type-Options: "nosniff"');
 
+require dirname(__FILE__).'/../inc/admin/prepend.php';
+
 // Specify log file
-define('LOGFILE',dirname(__FILE__).'/csp_report.txt');
+define('LOGFILE',path::real(DC_TPL_CACHE).'/csp_report.txt');
 
 // Get the raw POST data
Index: admin/install/index.php
===================================================================
--- admin/install/index.php	(revision 3303)
+++ admin/install/index.php	(revision 3326)
@@ -172,4 +172,5 @@
 		# CSP directive (admin part)
 		$blog_settings->system->put('csp_admin_on',true,'boolean','Send CSP header (admin)',true,true);
+		$blog_settings->system->put('csp_admin_report_only',false,'boolean','CSP Report only violations (admin)',true,true);
 		$blog_settings->system->put('csp_admin_default',"'self'",'string','CSP default-src directive',true,true);
 		$blog_settings->system->put('csp_admin_script',"'self' 'unsafe-inline' 'unsafe-eval'",'string','CSP script-src directive',true,true);
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 3294)
+++ admin/js/common.js	(revision 3332)
@@ -604,6 +604,7 @@
         });
 
-        $('#gototop').click(function() {
+        $('#gototop').click(function(e) {
             $('body,html').animate({scrollTop:0},800);
+            e.preventDefault();
         });
 });
Index: admin/js/jquery/jquery.pageTabs.js
===================================================================
--- admin/js/jquery/jquery.pageTabs.js	(revision 2479)
+++ admin/js/jquery/jquery.pageTabs.js	(revision 3333)
@@ -1,5 +1,5 @@
 (function($) {
 	'use strict';
-    
+
 	$.pageTabs = function(start_tab, opts) {
 		var defaults = {
@@ -10,8 +10,9 @@
 			idTabPrefix: 'part-tabs-'
 		};
-		
+
 		$.pageTabs.options = $.extend({}, defaults, opts);
 		var active_tab = start_tab || '';
 		var hash = $.pageTabs.getLocationHash();
+		var subhash = $.pageTabs.getLocationSubhash();
 
 		if (hash !== undefined && hash) {
@@ -23,5 +24,5 @@
 
 		createTabs();
-		
+
 		$('ul li', '.'+$.pageTabs.options.containerClass).click(function(e) {
 			if ($(this).hasClass($.pageTabs.options.activeClass)) {
@@ -40,5 +41,5 @@
 				part_to_activate.addClass('loaded');
 			}
-			
+
 			part_to_activate.tabload();
 		});
@@ -49,11 +50,16 @@
 
 		$.pageTabs.clickTab(active_tab);
-		
+
+		if (subhash !== undefined) {
+			// Tab displayed, now scroll to the sub-part if defined in original document.location (#tab.sub-part)
+			document.getElementById(subhash).scrollIntoView();
+		}
+
 		return this;
 	};
-	
+
 	var createTabs = function createTabs() {
 		var lis = [], li_class = '';
-		
+
 		$('.'+$.pageTabs.options.contentClass).each(function() {
 			$(this).hide();
@@ -62,9 +68,9 @@
 			$(this).attr('id', $.pageTabs.options.partPrefix + $(this).attr('id')).prop('title','');
 		});
-		
+
 		$('<div class="'+$.pageTabs.options.containerClass+'"><ul>'+lis.join('')+'</ul></div>')
 			.insertBefore($('.'+$.pageTabs.options.contentClass).get(0));
 	};
-	
+
 	var getHash = function getHash(href) {
 		var href = href || '';
@@ -72,5 +78,5 @@
 		return href.replace(/.*#/, '');
 	};
-	
+
 	$.pageTabs.clickTab = function(tab) {
 		if (tab=='') {
@@ -96,5 +102,12 @@
 
 	$.pageTabs.getLocationHash = function() {
-		return getHash(document.location.hash);
+		// Return the URL hash (without subhash — #hash[.subhash])
+		var h = getHash(document.location.hash).split('.');
+		return h[0];
+	};
+	$.pageTabs.getLocationSubhash = function() {
+		// Return the URL subhash if present (without hash — #hash[.subhash])
+		var sh = getHash(document.location.hash).split('.');
+		return sh[1];
 	};
 })(jQuery);
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 3295)
+++ admin/media.php	(revision 3340)
@@ -35,5 +35,5 @@
 
 $page = !empty($_GET['page']) ? max(1,(integer) $_GET['page']) : 1;
-$nb_per_page = ((integer) $core->auth->user_prefs->interface->media_by_page ? (integer) $core->auth->user_prefs->interface->media_by_page : 30);
+$nb_per_page = ((integer) $core->auth->user_prefs->interface->media_by_page ?: 30);
 
 # We are on home not comming from media manager
@@ -75,8 +75,14 @@
 $file_mode = !empty($_SESSION['media_file_mode']) ? $_SESSION['media_file_mode'] : 'grid';
 
-if (!empty($_GET['file_sort']) && in_array($_GET['file_sort'],$sort_combo)) {
-	$_SESSION['media_file_sort'] = $_GET['file_sort'];
-}
-$file_sort = !empty($_SESSION['media_file_sort']) ? $_SESSION['media_file_sort'] : null;
+$file_sort = null;
+if (!empty($_GET['file_sort'])) {
+	$file_sort = $_SESSION['media_file_sort'] = $_GET['file_sort'];
+	setcookie('dc_media_sort',json_encode($file_sort));
+} elseif (isset($_COOKIE['dc_media_sort'])) {
+	$file_sort = json_decode($_COOKIE['dc_media_sort']);
+} elseif (!empty($_SESSION['media_file_sort'])) {
+	$file_sort = $_SESSION['media_file_sort'];
+}
+$file_sort =  in_array($file_sort,$sort_combo) ? $file_sort : null;
 
 $nb_per_page = !empty($_SESSION['nb_per_page']) ? (integer)$_SESSION['nb_per_page'] : $nb_per_page;
@@ -155,5 +161,5 @@
 			$zip->addDirectory($core->media->root.'/'.$d,'',true);
 
-			header('Content-Disposition: attachment;filename='.date('Y-m-d').'-'.$core->blog->id.'-'.($d ? $d : 'media').'.zip');
+			header('Content-Disposition: attachment;filename='.date('Y-m-d').'-'.$core->blog->id.'-'.($d ?: 'media').'.zip');
 			header('Content-Type: application/x-zip');
 			$zip->write();
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 3167)
+++ admin/media_item.php	(revision 3353)
@@ -185,5 +185,5 @@
 
 # Function to get image title based on meta
-function dcGetImageTitle($file,$pattern,$dto_first=false,$no_date_alone=false)
+$get_img_title = function ($file,$pattern,$dto_first=false,$no_date_alone=false)
 {
 	$res = array();
@@ -225,5 +225,5 @@
 	}
 	return implode($sep,$res);
-}
+};
 
 /* DISPLAY Main page
@@ -307,5 +307,5 @@
 	{
 		$media_type = 'image';
-		$media_desc = dcGetImageTitle($file,
+		$media_desc = $get_img_title($file,
 			$core->blog->settings->system->media_img_title_pattern,
 			$core->blog->settings->system->media_img_use_dto_first,
@@ -376,5 +376,5 @@
 	{
 		$media_type = 'image';
-		$media_desc = dcGetImageTitle($file,
+		$media_desc = $get_img_title($file,
 			$core->blog->settings->system->media_img_title_pattern,
 			$core->blog->settings->system->media_img_use_dto_first,
Index: admin/plugin.php
===================================================================
--- admin/plugin.php	(revision 2708)
+++ admin/plugin.php	(revision 3333)
@@ -78,4 +78,11 @@
 	call_user_func($open_f,$p_title,$p_head);
 	echo $p_content;
+	if (!$popup) {
+		// Add direct links to plugin settings if any
+		$settings = adminModulesList::getSettingsUrls($core,$p,true,false);
+		if (!empty($settings)) {
+			echo '<hr class="clear"/><p class="right modules">'.implode(' - ',$settings).'</p>';
+		}
+	}
 	call_user_func($close_f);
 }
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 3209)
+++ admin/post.php	(revision 3340)
@@ -272,5 +272,5 @@
 
 	$cur->post_title = $post_title;
-	$cur->cat_id = ($cat_id ? $cat_id : null);
+	$cur->cat_id = ($cat_id ?: null);
 	$cur->post_dt = $post_dt ? date('Y-m-d H:i:00',strtotime($post_dt)) : '';
 	$cur->post_format = $post_format;
Index: admin/posts.php
===================================================================
--- admin/posts.php	(revision 3209)
+++ admin/posts.php	(revision 3360)
@@ -136,4 +136,10 @@
 	__('Number of trackbacks') => 'nb_trackback'
 	);
+
+	$sortby_lex = array(
+		// key in sorty_combo (see above) => field in SQL request
+		'post_title' => 'post_title',
+		'cat_title' => 'cat_title',
+		'user_id' => 'P.user_id');
 
 	$order_combo = array(
@@ -275,6 +281,11 @@
 # - Sortby and order filter
 if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if (array_key_exists($sortby,$sortby_lex)) {
+		$params['order'] = $core->con->lexFields($sortby_lex[$sortby]);
+	} else {
+		$params['order'] = $sortby;
+	}
 	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
+		$params['order'] .= ' '.$order;
 	} else {
 		$order='desc';
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 3265)
+++ admin/preferences.php	(revision 3340)
@@ -47,5 +47,5 @@
 $user_ui_iconset = @$core->auth->user_prefs->interface->iconset;
 $user_ui_nofavmenu = $core->auth->user_prefs->interface->nofavmenu;
-$user_ui_media_by_page = ($core->auth->user_prefs->interface->media_by_page ? $core->auth->user_prefs->interface->media_by_page : 30);
+$user_ui_media_by_page = ($core->auth->user_prefs->interface->media_by_page ?: 30);
 $user_ui_media_nb_last_dirs = $core->auth->user_prefs->interface->media_nb_last_dirs;
 
@@ -98,4 +98,21 @@
 # Language codes
 $lang_combo = dcAdminCombos::getAdminLangsCombo();
+
+# Get 3rd parts xhtml editor flags
+$rte = array(
+	'blog_descr' => array(true,__('Blog description (in blog parameters)')),
+	'cat_descr' => array(true,__('Category description'))
+);
+$rte = new ArrayObject($rte);
+$core->callBehavior('adminRteFlags',$core,$rte);
+# Load user settings
+$rte_flags = @$core->auth->user_prefs->interface->rte_flags;
+if (is_array($rte_flags)) {
+	foreach ($rte_flags as $fk => $fv) {
+		if (isset($rte[$fk])) {
+			$rte[$fk][0] = $fv;
+		}
+	}
+}
 
 # Get default colums (admin lists)
@@ -233,4 +250,11 @@
 		}
 		$core->auth->user_prefs->interface->put('cols',$cu,'array');
+
+		# Update user xhtml editor flags
+		$rf = array();
+		foreach ($rte as $rk => $rv) {
+			$rf[$rk] = isset($_POST['rte_flags']) && in_array($rk,$_POST['rte_flags'],true) ? true : false;
+		}
+		$core->auth->user_prefs->interface->put('rte_flags',$rf,'array');
 
 		# Update user
@@ -466,5 +490,5 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Interface').'</h4>'.
+'<h4 id="user_options_interface">'.__('Interface').'</h4>'.
 
 '<p><label for="user_ui_enhanceduploader" class="classic">'.
@@ -500,12 +524,16 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Optional columns displayed in lists').'</h4>';
+'<h4 id="user_options_columns">'.__('Optional columns displayed in lists').'</h4>';
+$odd = true;
 foreach ($cols as $col_type => $col_list) {
+	echo '<div class="two-boxes '.($odd ? 'odd' : 'even').'">';
 	echo '<h5>'.$col_list[0].'</h5>';
 	foreach ($col_list[1] as $col_name => $col_data) {
 		echo
-		'<p><label for="cols_'.$col_type.'-"'.$col_name.'" class="classic">'.
+		'<p><label for="cols_'.$col_type.'-'.$col_name.'" class="classic">'.
 		form::checkbox(array('cols_'.$col_type.'[]','cols_'.$col_type.'-'.$col_name),$col_name,$col_data[0]).$col_data[1].'</label>';
 	}
+	echo '</div>';
+	$odd = !$odd;
 }
 echo '</div>';
@@ -513,6 +541,7 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Edition').'</h4>';
-
+'<h4 id="user_options_edition">'.__('Edition').'</h4>';
+
+echo '<div class="two-boxes odd">';
 foreach ($format_by_editors as $format => $editors) {
 	echo
@@ -544,4 +573,15 @@
 
 '</div>';
+
+echo '<div class="two-boxes even">';
+echo '<h5>'.__('Use xhtml editor for:').'</h5>';
+foreach ($rte as $rk => $rv) {
+	echo
+		'<p><label for="rte_'.$rk.'" class="classic">'.
+		form::checkbox(array('rte_flags[]','rte_'.$rk),$rk,$rv[0]).$rv[1].'</label>';
+}
+echo '</div>';
+
+echo '</div>';	// fieldset
 
 echo
Index: admin/style/config.rb
===================================================================
--- admin/style/config.rb	(revision 3355)
+++ admin/style/config.rb	(revision 3355)
@@ -0,0 +1,19 @@
+# Require any additional compass plugins here.
+
+# Set this to the root of your project when deployed:
+http_path = "./"
+css_dir = "./"
+sass_dir = "scss"
+images_dir = "img"
+javascripts_dir = "scripts"
+
+# You can select your preferred output style here (can be overridden via the command line):
+# output_style = :expanded or :nested or :compact or :compressed
+# To enable relative paths to assets via compass helper functions. Uncomment:
+# relative_assets = true
+# To disable debugging comments that display the original location of your selectors. Uncomment:
+output_style = :nested
+environment = :development
+line_comments = false
+
+Sass::Script::Number.precision = 7
Index: admin/users.php
===================================================================
--- admin/users.php	(revision 3182)
+++ admin/users.php	(revision 3360)
@@ -23,4 +23,11 @@
 __('Number of entries') => 'nb_post'
 );
+
+$sortby_lex = array(
+	// key in sorty_combo (see above) => field in SQL request
+	'user_id' => 'U.user_id',
+	'user_name' => 'user_name',
+	'user_firstname' => 'user_firstname',
+	'user_displayname' => 'user_displayname');
 
 $order_combo = array(
@@ -66,6 +73,11 @@
 # - Sortby and order filter
 if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if (array_key_exists($sortby,$sortby_lex)) {
+		$params['order'] = $core->con->lexFields($sortby_lex[$sortby]);
+	} else {
+		$params['order'] = $sortby;
+	}
 	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
+		$params['order'] .= ' '.$order;
 	} else {
 		$order='asc';
